package de.scandio.tree;

import org.springframework.roo.addon.entity.RooEntity;
import org.springframework.roo.addon.javabean.RooJavaBean;
import org.springframework.roo.addon.tostring.RooToString;
import javax.persistence.ManyToOne;
import java.util.Set;
import java.util.HashSet;
import javax.persistence.EntityManager;
import javax.persistence.CascadeType;
import javax.persistence.OneToMany;
import javax.persistence.TypedQuery;

@RooJavaBean
@RooToString
@RooEntity
public class Node {

    private String name;

    @ManyToOne
    private Node parent;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "parent")
    private Set<de.scandio.tree.Node> children = new HashSet<de.scandio.tree.Node>();

    public static TypedQuery<Node> findRootNodes() {
        EntityManager em = Node.entityManager();
        TypedQuery<Node> q = em.createQuery("SELECT Node FROM Node AS node WHERE node.parent IS NULL", Node.class);
        return q;
    }
}
